/* Nintendulator Mapper DLLs
* Copyright (C) 2002-2011 QMT Productions
*
*/

/* emulates bankswitching only, not FlashROM yet */

#include	"..\DLL\d_iNES.h"

namespace
{
	uint8 map_reg;

	void	Sync(void)
	{
		EMU->SetPRG_ROM32(0x8, map_reg & 0x0F);
		EMU->SetCHR_RAM8(0, (map_reg & 0x10) >> 4);
	}

	void	SyncNametables(void)
	{
		EMU->SetCHR_RAM1(0x8, ((map_reg & 0x20) >> 3) + 16);
		EMU->SetCHR_RAM1(0x9, ((map_reg & 0x20) >> 3) + 17);
		EMU->SetCHR_RAM1(0xA, ((map_reg & 0x20) >> 3) + 18);
		EMU->SetCHR_RAM1(0xB, ((map_reg & 0x20) >> 3) + 19);
	}


	int	MAPINT	SaveLoad(STATE_TYPE mode, int offset, unsigned char *data)
	{
		SAVELOAD_BYTE(mode, offset, data, map_reg);
		if (mode == STATE_LOAD)
			Sync();
		return offset;
	}

	void	MAPINT	Write(int Bank, int Addr, int Val)
	{
		map_reg = Val;
		Sync();
		SyncNametables();
	}


	BOOL	MAPINT	Load(void)
	{
		iNES_SetSRAM();
		return TRUE;
	}

	void	MAPINT	Reset(RESET_TYPE ResetType)
	{
		EMU->Mirror_4();
		EMU->SetCPUWriteHandler(0x5, Write);
		EMU->SetCPUWriteHandler(0x7, Write);
		if (ResetType == RESET_HARD)
			map_reg = 0xFF;
		Sync();
		SyncNametables();
	}

	uint16 MapperNum = 111;
} // namespace

const MapperInfo MapperInfo_111 =
{
	&MapperNum,
	_T("GTROM / Cheapocabra"),
	COMPAT_PARTIAL,
	Load,
	Reset,
	NULL,
	NULL,
	NULL,
	SaveLoad,
	NULL,
	NULL
};
